unsigned char r,g,b;

float h = 0.0;
float s = 1.0;
float v = .8; //.8  

  byte red_min = 0;
  byte red_max = 255;
  
  byte blue_min = 0;
  byte blue_max = 160;
  
  byte green_min = 0;
  byte green_max = 160;

//http://blog.appliedplatonics.com/?p=9

RGBW hsv_to_rgb(float h, float s, float v) {
  
  int h_i = ((int)(h/60)) % 6;
  
  float f = (h/60) - (int)(h/60);
  
  float r,g,b;
  
  float p = v * (1.0 - s);
  float q = v * (1.0 - f*s);
  float t = (1.0 - (1.0 - f)*s);
  
  switch(h_i) {
    case 0:  r = v; g = t; b = p; break;
    case 1:  r = q; g = v; b = p; break;
    case 2:  r = p; g = v; b = t; break;
    case 3:  r = p; g = q; b = v; break;
    case 4:  r = t; g = p; b = v; break;
    case 5:  r = v; g = p; b = q; break;
  }



  
  RGBW color;
  
  color.r = red_max - (byte)((red_max - red_min)*r);
  color.g = green_max - (byte)((green_max - green_min)*g);
  color.b = blue_max - (byte)((blue_max - blue_min)*b);
  color.w = 0;
  
  return color;
}


void shiftColorLeft(RGBW color) {
  for(int i=1; i<LED_COUNT; i++) {
    leds[i-1] = leds[i];
  }
  leds[LED_COUNT-1] = color;
 
}  

void shiftColorRight(RGBW color) {
  for(int i=LED_COUNT-2; i>=0; i--) {
    leds[i+1] = leds[i];
  }
  leds[0] = color;
}  

boolean shiftDirection(RGBW color) {

  if(directionPot < 1 && directionPot > -1 ) {
    return false;
  }
 
  if(programMillis+pow(8,4-abs(directionPot)) < millis()) {
    lcd.setCursor(5, 1);
    lcd.print(pow(6,4-abs(directionPot)));
    if(directionPot >= 1) {
      shiftColorRight((RGBW) color);
     
    }
    else if(directionPot <= -1) {
      shiftColorLeft((RGBW) color);
      
    }
    programMillis = millis();
    return true;
  } 
   return false;
  
}

void setAll(RGBW color) {
  for(int i=0; i<LED_COUNT; i++) {
    leds[i] = color;

  }
}  

void clearAll() {
  setAll((RGBW){0,0,0,0});
}  

typedef struct {
  float h;
  float s;
  float b;
} HSB;

//from

HSB RGBToHSB(RGBW color) {
double minRGB, maxRGB, delta;
double h, s, b;
   h = 0;
   minRGB = min(min(color.r, color.g), color.b);
   maxRGB = max(max(color.r, color.g), color.b);
   delta = (maxRGB - minRGB);
   b = maxRGB;
   if(maxRGB != 0) {
    s = 255 * delta / maxRGB;
   } else {
    s = 0;
   }
   
  if(s != 0) {
    if(color.r == maxRGB) {
      h = (float)(color.g - color.b) / delta;
    } else {
      if(color.g == maxRGB) {
        h = 2 + (float)(color.b - color.r) / delta;
      } else {
        if(color.b == maxRGB) {
          h = 4 + (float)(color.r - color.g) / delta;
        }
      }
    }
  } else {
    h = -1;
  }
  h = h * 60;
  if( h < 0) {
    h = h + 360;
  }
  HSB HSBColor;
  HSBColor.h = h;
  HSBColor.s = s * 100 / 255;
  HSBColor.b = b * 100 / 255;
  return HSBColor;
}

RGBW HSBToRGB(HSB HSBColor) {

  if(HSBColor.h > 360){ HSBColor.h -=360;}
  
  
  float delta;
  float  h, s, b;
  RGBW RGBColor;
  h = HSBColor.h / 60;
  s = HSBColor.s * 255 / 100;
  b = HSBColor.b * 255 / 100;

  if (s == 0) {
    RGBColor.r = 0;
    RGBColor.g = 0;
    RGBColor.b = 0;
  } else {
   delta = s * b / 255;
        if(h > 3) {
           RGBColor.b = (round(b));
             if(h > 4) {
                  RGBColor.g = round(b - delta);
                  RGBColor.r = round((h - 4) * delta) + RGBColor.g;
             } else {
                  RGBColor.r = round(b - delta);
                  RGBColor.g = RGBColor.r - round((h - 4) * delta);
             }
        } else {
       if(h > 1) {
               RGBColor.g = round(b);
                  if(h > 2) {
                       RGBColor.r = round(b - delta);
                       RGBColor.b = round((h - 2) * delta) + RGBColor.r;
                  } else {
                       RGBColor.b = round(b - delta);
                       RGBColor.r = RGBColor.b - round((h - 2) * delta);
                  }
             } else {
                  if(h > -1) {
                       RGBColor.r = round(b);
                       if(h > 0) {
                            RGBColor.b = round(b - delta);
                            RGBColor.g = round(h * delta) + RGBColor.b;
                       } else {
                            RGBColor.g = round(b - delta);
                            RGBColor.b = RGBColor.g - round(h * delta);
                       }
                  }
             }
        }
   }

  return RGBColor;
}



